package org.zeroturnaround.javarebel.integration.servlet.oc4j;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtNewMethod;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>com.evermind.server.http.deployment.ServletDescriptor</code>.
 * 
 * @author Rein Raudjärv
 */
public class ServletDescriptorCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    ctClass.addInterface(cp.get(ServletDescriptorExtra.class.getName()));
    
    boolean parentFieldExists = false;
    try {
      ctClass.getField("parent");
      parentFieldExists = true;
    } catch (NotFoundException e) {
    }
    
    if (parentFieldExists)
      ctClass.addMethod(CtNewMethod.make(
          "public void __setParent(Object parent) { this.parent = (com.evermind.util.AbstractDescribable) parent; }", ctClass));
    else
      ctClass.addMethod(CtNewMethod.make(
          "public void __setParent(Object parent) {}", ctClass));
  }
}
