package org.zeroturnaround.javarebel.integration.servlet.weblogic;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtConstructor;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>weblogic.servlet.jsp.JspConfig<code>
 * to enable JSP updates in production mode.
 * 
 * @author Rein Raudjärv
 * 
 * @see WebAppConfigManagerCBP
 */
public class JspConfigCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    CtConstructor[] constructors = ctClass.getConstructors();
    for (int i = 0; i < constructors.length; i++) {
      CtConstructor constructor = constructors[i];
      constructor.insertAfter(
          "{" +
          "  if (this.pageCheckSeconds == -1)" +
          "    this.pageCheckSeconds = 1;" +
          "}");
    }
  }

}
