package org.zeroturnaround.javarebel.integration.servlet.weblogic;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>weblogic.servlet.internal.ServletStubImpl<code>.
 * <p>
 * Used for Weblogic 9.x and 10.x JSP updates.
 * 
 * @author Rein Raudjärv
 */
public class ServletStubImplCBP extends JavassistClassBytecodeProcessor {
  
  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    try {
      CtMethod m = ctClass.getDeclaredMethod("execute", new CtClass[] {
          cp.get("javax.servlet.ServletRequest"),
          cp.get("javax.servlet.ServletResponse"),
          cp.get("weblogic.servlet.internal.FilterChainImpl"),
      });
      m.insertBefore("{" +
      		"  " + JspUpdateUtil.class.getName() + ".handleJspUpdate(" +
      		"    $0.context, $0.context.getRootTempDir(), $1, $2);" +
      		"}");
    }
    catch (NotFoundException e) {
      /*
       * Weblogic 8 has no such method but works correctly
       * because of method WebAppServletContext.getResourceAsSource() 
       */
    }
  }

  
}
